routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('index');
})->name('home');

Route::get('/install', function () {
    return response()->download(public_path('download/BeadPsikotes.apk'));
})->name('install');


// API
Route::post('/api/register', 'RegisterController@store');
Route::post('/api/login', 'LoginController@store');
Route::group(['middleware' => 'auth:api', 'prefix' => 'api'], function () {
    Route::post('/user', 'UserController@show');
    Route::apiResource('/instansi', 'InstansiController');
    Route::resource('/question', 'QuestionController');
    Route::post('score/send', 'ScoreController@send');
    Route::post('pdf', 'PDFController@download');
});

// Web
Route::get('login', 'Dashboard\DashboardController@login')->name('login');
Route::post('login', 'Dashboard\DashboardController@store')->name('login-post');
Route::group(['middleware' => ['auth']], function () {
    Route::group(['prefix' => 'dashboard'], function () {
        Route::post('logout', 'Dashboard\DashboardController@destroy')->name('logout');
        Route::resource('buatcv', 'Dashboard\BuatCVController');
        Route::group(['middleware' => ['isAdmin'], 'prefix' => 'admin'], function () {
            Route::resource('user', 'Dashboard\Admin\UserController', ['as' => 'admin']);
            Route::post('settings/activate', 'Dashboard\Admin\SettingsController@activate', ['as' => 'admin'])->name('activate');
            Route::resource('settings', 'Dashboard\Admin\SettingsController', ['as' => 'admin']);
            Route::resource('instansi', 'Dashboard\Admin\InstansiController', ['as' => 'admin']);
            Route::resource('report', 'Dashboard\Admin\ReportController', ['as' => 'admin']);
            Route::resource('category', 'Dashboard\Admin\CategoryController', ['as' => 'admin']);
            Route::resource('question', 'Dashboard\Admin\QuestionController', ['as' => 'admin']);
        });
    });
    Route::resource('dashboard', 'Dashboard\DashboardController');
});

app/Question.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Question extends Model
{
    //
    protected $fillable = [
        'soal', 'opsi1', 'opsi2', 'opsi3', 'opsi4', 'opsi5', 'jawaban'
    ];
}

app/Http/Controllers/Dashboard/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Category;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $category = Category::all();
        return view('dashboard.category.index')->with([
            'categories' => $category
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return view('dashboard.category.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $category = new Category();
        $category->name = $request->name;
        $category->save();
        return redirect()->back()->with('success', 'Berhasil menambahkan kategori: <b>'. $category->name .'</b>');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Dashboard/Admin/InstansiController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Instansi;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class InstansiController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $instansis = Instansi::all();
        return view('dashboard.instansi.index')->with([
            'instansis' => $instansis
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return view('dashboard.instansi.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $numbers = str_split((string)(int)microtime(true));
        shuffle($numbers);
        $rand = '';
        foreach (array_rand($numbers, 6) as $k) $rand .= $numbers[$k];
        $instansi = new Instansi();
        $instansi->kode = $rand;
        $instansi->nama = $request->nama;
        $instansi->save();
        return redirect()->back()->with('success', "Penambahan instansi berhasil");
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Dashboard/Admin/QuestionController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Category;
use App\Question;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class QuestionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        if (!Category::all()->count()) {
            return redirect()->route('dashboard.category.create')->with('error', 'Tambah kategori terlebih dahulu');
        }
        $questions = Question::all();
        return view('dashboard.question.index')->with([
            'questions' => $questions
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        if (!Category::all()->count()) {
            return redirect()->route('dashboard.category.create')->with('error', 'Tambah kategori terlebih dahulu');
        }
        return view('dashboard.question.create')->with('categories', Category::all());
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $question = new Question();
        $question->soal = $request->soal;
        $question->opsi1 = $request->opsi1;
        $question->opsi2 = $request->opsi2;
        $question->opsi3 = $request->opsi3;
        $question->opsi4 = $request->opsi4;
        $question->opsi5 = $request->opsi5;
        $question->jawaban = $request->jawaban;
        $question->category_id = $request->category;
        $question->save();
        return redirect()->back()->with('success', 'Berhasil menambahkan soal #'.$question->id);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Dashboard/Admin/ReportController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Instansi;
use App\Score;
use App\User;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ReportController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $instansis = Instansi::all();
        return view('dashboard.report.index')->with([
            'instansis' => $instansis
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        return redirect()->route('admin.report.show', ['id' => $request->instansi]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
        $users = User::whereHas('score', function ($q) use ($id){
            $q->where('instansi_id', $id);
        })->get();
        return view('dashboard.report.show')->with([
            'users' => $users
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $user = User::find($id);
        $user->score()->delete();
        return redirect()->back()->with('success', 'Berhasil menghapus nilai');
    }
}

app/Http/Controllers/Dashboard/Admin/SettingsController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Settings;
use Artisan;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SettingsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        if (\Schema::hasTable('settings')){
            $active = Settings::where('config', 'active')->first();
            return view('dashboard.settings.index')->with([
                'active' => $active
            ]);
        }
        else return view('dashboard.settings.index');

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        switch ($request->action){
            case 'migrate':
                Artisan::call('migrate');
                break;
            case 'rollback':
                Artisan::call('migrate:rollback');
                break;
        }
        return redirect()->back()->with('success', Artisan::output());
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function activate(Request $request){
        $settings = Settings::where('config', 'active')->first();
        $settings->value = $request->active;
        $settings->save();
        if ($request->active == "1"){
            $status = 'success';
            $message = 'Server berhasil dinyalakan';
        }
        elseif ($request->active == "2"){
            $status = 'error';
            $message = 'Server dimatikan';
        }
        return redirect()->back()->with($status, $message);
    }
}

app/Http/Controllers/Dashboard/Admin/UserController.php
<?php

namespace App\Http\Controllers\Dashboard\Admin;

use App\Instansi;
use App\User;
use Hash;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Validator;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $user = User::all();
        return view('dashboard.user.review')->with([
            'users' => $user
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $instansi = Instansi::all();
        return view('dashboard.user.create')->with([
            'instansis' => $instansi
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $validator = Validator::make($request->all(),
            [
                'nama' => ['required', 'string', 'max:255'],
                'email' => ['required', 'string', 'email', 'max:255', 'unique:users'],
                'password' => ['required', 'string', 'min:6'],
            ],
            [
                'nama.required' => 'Kolom nama harus di isi',
                'email.required' => 'Kolom email harus di isi',
                'email.unique' => 'Email sudah digunakan',
                'password.required' => 'Kolom password harus di isi',
            ]);
        if ($validator->passes()) {
                $user = User::create([
                    'name' => $request->nama,
                    'email' => $request->email,
                    'password' => Hash::make($request->password),
                ]);
                return redirect()->back()->with('success', 'Pendaftaran user baru: '. $user->name .' berhasil');
        }
        else{
            return redirect()->back()->with('success', implode(", ", $validator->errors()->all()));
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        if (\Auth::id() == $id){
            return redirect()->back()->with('error', 'Tidak bisa menghapus akun sendiri');
        }
        $user = User::find($id);
        $user->delete();
        return redirect()->back()->with('success', 'Berhasil menghapus user');
    }
}

resources/views/dashboard/question/create.blade.php
@extends('layouts.dashboard')

@section('title', 'Soal')

@section('content')
    <section class="content-header">
        <h1>Soal <a href="{{ route('admin.question.create') }}" class="btn btn-primary">Tambah</a></h1>
        <ol class="breadcrumb">
            <li><a href="{{ route('admin.question.index') }}"><i class="fa fa-dashboard"></i> Soal</a></li>
        </ol>
    </section>
    <section class="content">
        @if ($message = Session::get('success'))
            <div class="alert alert-success alert-dismissible">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                {{ $message }}
            </div>
        @endif
        <div class="row">
            <div class="col-md-12">
                <div class="box">
                    <div class="box-body">
                        <div class="row">
                            <div class="col-md-12">
                                <form class="form-horizontal" action="{{ route('admin.question.store') }}" method="POST">
                                    @csrf
                                    <div class="box-body">
                                        <div class="form-group">
                                            <div class="col-sm-12">
                                                <label for="soal">Soal:</label>
                                                <textarea name="soal" id="soal" class="form-control"></textarea>
                                            </div>
                                            <div class="col-sm-12">
                                                <label for="opsi1">Opsi 1:</label>
                                                <textarea name="opsi1" id="opsi1" class="form-control"></textarea>
                                            </div>
                                            <div class="col-sm-12">
                                                <label for="opsi2">Opsi 2:</label>
                                                <textarea name="opsi2" id="opsi2" class="form-control"></textarea>
                                            </div>
                                            <div class="col-sm-12">
                                                <label for="opsi3">Opsi 3:</label>
                                                <textarea name="opsi3" id="opsi3" class="form-control"></textarea>
                                            </div>
                                            <div class="col-sm-12">
                                                <label for="opsi4">Opsi 4:</label>
                                                <textarea name="opsi4" id="opsi4" class="form-control"></textarea>
                                            </div>
                                            <div class="col-sm-12">
                                                <label for="opsi5">Opsi 5:</label>
                                                <textarea name="opsi5" id="opsi5" class="form-control"></textarea>
                                            </div>
                                            <div class="col-sm-12">
                                                <label for="jawaban">Jawaban:</label>
                                                <select name="jawaban" id="jawaban" class="form-control">
                                                    <option value="1">A</option>
                                                    <option value="2">B</option>
                                                    <option value="3">C</option>
                                                    <option value="4">D</option>
                                                    <option value="5">E</option>
                                                </select>
                                            </div>
                                            <div class="col-sm-12">
                                                <label for="category">Kateogi</label>
                                                <select name="category" id="category" class="form-control">
                                                    @foreach($categories as $category)
                                                        <option value="{{ $category->id }}">{{ $category->name }}</option>
                                                    @endforeach
                                                </select>
                                            </div>
                                            <div class="col-sm-12">
                                                <div class="box-footer text-center">
                                                    <button type="submit" class="btn btn-info">Tambah Soal</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

resources/views/dashboard/question/edit.blade.php
@extends('layouts.dashboard')

@section('title', 'Soal')

@section('content')

@endsection

resources/views/dashboard/question/index.blade.php
@extends('layouts.dashboard')

@section('title', 'Soal')

@section('customcss')
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/bs/jszip-2.5.0/dt-1.10.18/b-1.5.6/b-html5-1.5.6/b-print-1.5.6/datatables.min.css"/>
@endsection

@section('content')
    <section class="content-header">
        <h1>Soal <a href="{{ route('admin.question.create') }}" class="btn btn-primary">Tambah</a></h1>
        <ol class="breadcrumb">
            <li><a href="{{ route('admin.question.index') }}"><i class="fa fa-dashboard"></i> Soal</a></li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="box">
                    <div class="box-body">
                        <div class="row">
                            <div class="col-md-12">
                                <table id="questions" class="table table-bordered table-striped">
                                    <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Soal</th>
                                        <th>Opsi 1</th>
                                        <th>Opsi 2</th>
                                        <th>Opsi 3</th>
                                        <th>Opsi 4</th>
                                        <th>Opsi 5</th>
                                        <th>Jawaban</th>
                                        <th>Aksi</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    @foreach ($questions as $question)
                                        <tr>
                                            <td>{{$question->id}}</td>
                                            <td>{{$question->soal}}</td>
                                            <td>{{$question->opsi1}}</td>
                                            <td>{{$question->opsi2}}</td>
                                            <td>{{$question->opsi3}}</td>
                                            <td>{{$question->opsi4}}</td>
                                            <td>{{$question->opsi5}}</td>
                                            <td>{{$question->jawaban}}</td>
                                            <td>aksi</td>
                                        </tr>
                                    @endforeach
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

@section('customscript')
    <!-- DataTables -->
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/v/bs/jszip-2.5.0/dt-1.10.18/b-1.5.6/b-html5-1.5.6/b-print-1.5.6/datatables.min.js"></script>
    <script>
        $(function () {
            var table = $('#questions').DataTable( {
                buttons: [
                    {
                        extend: 'copy',
                        exportOptions: {
                            columns: 'th:not(:last-child)'
                        }
                    },
                    {
                        extend: 'excel',
                        exportOptions: {
                            columns: 'th:not(:last-child)'
                        }
                    },
                    {
                        extend: 'pdf',
                        exportOptions: {
                            columns: 'th:not(:last-child)'
                        }
                    }
                ]
            } );

            table.buttons().container()
                .appendTo( $('.col-sm-6:eq(0)', table.table().container() ) );
        })
    </script>
@endsection

resources/views/dashboard/question/show.blade.php
@extends('layouts.dashboard')

@section('title', 'Soal')

@section('content')

@endsection